﻿Public Class Sort
    Private Declare Auto Function FindWindow Lib "user32.dll" (ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr
    Private Declare Auto Function FindWindowEx Lib "user32.dll" (ByVal hwndParent As IntPtr, ByVal hwndChildAfter As IntPtr, ByVal lpszClass As String, ByVal lpszWindow As String) As IntPtr
    Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As IntPtr) As IntPtr
    Private Declare Function SendStrMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As String) As IntPtr
    Private Declare Function SendNotifyMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As IntPtr, ByVal wMsg As UInteger, ByVal wParam As UIntPtr, ByVal lParam As IntPtr) As Boolean

    Private Const BM_CLICK = &HF5
    Private Const LB_SETCURSEL = &H186
    Private Const WM_KEYDOWN = &H100
    Private Const VK_UP = &H26
    Private Const VK_DOWN = &H28
    Private Const LB_GETTEXT As Int32 = &H189
    Private Const LB_GETTEXTLEN = &H18A


    Dim CATIA As INFITF.Application = Nothing
    Dim selProduct As ProductStructureTypeLib.Product = Nothing
    Dim uSel As INFITF.Selection = Nothing
    Dim initialOrder() As String
    Dim actWindow As INFITF.Window

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim countTest As Integer = 0

        For Each p As Process In Process.GetProcesses()
            If p.ProcessName = "CNEXT" Then
                If countTest = 1 Then
                    Me.Hide()
                    MsgBox("More than one instance of CATIA is running please make sure only one instance is running prior to running this program.")
                    Me.Close()
                    Environment.Exit(0)
                End If
                countTest = 1
            End If
        Next

        If countTest = 0 Then
            Me.Hide()
            MsgBox("CATIA is not running")
            Me.Close()
            Environment.Exit(0)
            End
        End If

        CATIA = GetObject(, "CATIA.application")

        Call loadSelValues()

    End Sub

    Sub loadSelValues()
        On Error GoTo clearSelected

        uSel = CATIA.ActiveDocument.Selection
        actWindow = CATIA.ActiveWindow

        If CATIA.ActiveDocument.Selection.Count2 = 1 Then
            If TypeName(uSel.Item2(1).Value) = "Product" Then
                If uSel.Item2(1).Value.products.count > 1 Then

                    SortedValues.Items.Clear()
                    InputValues.Items.Clear()
                    RunSort.Enabled = True
                    ReDim initialOrder(0)

                    selProduct = uSel.Item2(1).Value
                    actWindow = CATIA.ActiveWindow

                    ToolStripStatusLabel1.Text = "Loaded document: " & selProduct.PartNumber

                    For Each inProd In selProduct.Products
                        ReDim Preserve initialOrder(UBound(initialOrder) + 1)
                        initialOrder(UBound(initialOrder)) = " " & inProd.Name & " || (" & inProd.PartNumber & ")"
                        InputValues.Items.Add(" " & inProd.Name & " || (" & inProd.PartNumber & ")")
                    Next

                    If BoeAutoSort.Checked Then
                        MoveRight.PerformClick()
                        BoeDetSort.PerformClick()
                    ElseIf NamAutoSort.Checked Then
                        MoveRight.PerformClick()
                        NameSort.PerformClick()
                    End If
                Else
                    Err.Raise(1)
                End If
            Else
                Err.Raise(1)
            End If
        Else
            Err.Raise(1)
        End If
        Exit Sub

clearSelected:
        Err.Clear()
        RunSort.Enabled = False
        SortedValues.Items.Clear()
        InputValues.Items.Clear()
        selProduct = Nothing
        ToolStripStatusLabel1.Text = "Select a product to load..."
        Exit Sub
    End Sub

    Private Sub LoadSelected_Click(sender As Object, e As EventArgs) Handles LoadSelected.Click
        Call loadSelValues()
    End Sub

    Private Sub MoveRight_Click(sender As Object, e As EventArgs) Handles MoveRight.Click
        Dim item As String
        Dim i As Integer

        If InputValues.SelectedItems.Count = 0 Then
            For i = InputValues.Items.Count - 1 To 0 Step -1
                InputValues.SetSelected(i, True)
            Next
        End If

        For Each item In InputValues.SelectedItems
            SortedValues.Items.Add(item)
        Next

        For i = InputValues.Items.Count - 1 To 0 Step -1
            If InputValues.GetSelected(i) = True Then
                InputValues.Items.Remove(InputValues.Items.Item(i))
            End If
        Next

    End Sub

    Private Sub MoveLeft_Click(sender As Object, e As EventArgs) Handles MoveLeft.Click
        Dim item As String
        Dim i As Integer

        If SortedValues.SelectedItems.Count = 0 Then
            For i = SortedValues.Items.Count - 1 To 0 Step -1
                SortedValues.SetSelected(i, True)
            Next
        End If

        For Each item In SortedValues.SelectedItems
            InputValues.Items.Add(item)
        Next

        For i = SortedValues.Items.Count - 1 To 0 Step -1
            If SortedValues.GetSelected(i) = True Then
                SortedValues.Items.Remove(SortedValues.Items.Item(i))
            End If
        Next
    End Sub

    Private Sub RunSort_Click(sender As Object, e As EventArgs) Handles RunSort.Click
        Dim i As Integer
        Dim j As Integer
        Dim shiftVal As Integer
        Dim nextToMove As Integer
        Dim moveTo As Integer
        Dim reordHand As Long
        Dim timer As Date = Now
        Dim startTime As Date = Now
        Dim okButtonHand As Long
        Dim framWinHan As Long
        Dim framListHand As Long
        Dim framActHand As Long
        Dim reordListHand As Long
        Dim moveButtonHand As Long
        Dim valRet As Boolean
        Dim ordArr() As Integer
        Dim pastPos() As Integer
        Dim nextMoveString As String = ""
        Dim moveToString As String = ""
        Dim length As Long
        Dim totalMoves As Integer


        ToolStripStatusLabel1.Text = "Sort is running..."

        For i = InputValues.Items.Count - 1 To 0 Step -1
            InputValues.SetSelected(i, True)
        Next

        Call MoveRight_Click(Nothing, Nothing)

        actWindow.Activate()
        uSel.Clear()
        uSel.Add(selProduct)

        ordArr = returnOrder()

        If CATIA.GetWorkbenchId <> "Assembly" Then
            CATIA.StartWorkbench("Assembly")
        End If

        CATIA.StartCommand("Graph tree reordering")
        System.Threading.Thread.Sleep(100)

        timer = Now
        Do While reordHand = 0
            reordHand = FindWindow("#32770", "Graph tree reordering")
            If Now() > timer.AddSeconds(15) Then
                MsgBox("Falied to run graph tree reordering command",, "Error")
                Exit Sub
            End If
            System.Threading.Thread.Sleep(50)
        Loop

        timer = Now
        Do While okButtonHand = 0
            okButtonHand = FindWindowEx(reordHand, Nothing, "Button", "Ok")
            If Now() > timer.AddSeconds(5) Then
                MsgBox("Falied sync with graph tree reordering",, "Error")
                Exit Sub
            End If
        Loop

        timer = Now
        Do While framWinHan = 0
            framWinHan = FindWindowEx(reordHand, Nothing, Nothing, "FrameWindow")
            If Now() > timer.AddSeconds(5) Then
                MsgBox("Falied sync with graph tree reordering",, "Error")
                Exit Sub
            End If
        Loop

        timer = Now
        Do While framListHand = 0
            framListHand = FindWindowEx(framWinHan, Nothing, Nothing, "FrameList")
            If Now() > timer.AddSeconds(5) Then
                MsgBox("Falied sync with graph tree reordering",, "Error")
                Exit Sub
            End If
        Loop

        timer = Now
        Do While framActHand = 0
            framActHand = FindWindowEx(framWinHan, Nothing, Nothing, "FrameAction")
            If Now() > timer.AddSeconds(5) Then
                MsgBox("Falied sync with graph tree reordering",, "Error")
                Exit Sub
            End If
        Loop

        timer = Now
        Do While reordListHand = 0
            reordListHand = FindWindowEx(framListHand, Nothing, "ListBox", "ListProd")
            If Now() > timer.AddSeconds(5) Then
                MsgBox("Falied sync with graph tree reordering",, "Error")
                Exit Sub
            End If
        Loop

        timer = Now
        Do While moveButtonHand = 0
            moveButtonHand = FindWindowEx(framActHand, Nothing, "Button", "Free Move")
            If Now() > timer.AddSeconds(5) Then
                MsgBox("Falied sync with graph tree reordering",, "Error")
                Exit Sub
            End If
        Loop

        ReDim pastPos(0)
        pastPos(0) = Nothing
        totalMoves = UBound(ordArr) + 1
        For i = 0 To UBound(ordArr) Step 1
            nextToMove = ordArr(i) + 1
            moveTo = i + 1
            shiftVal = 0

            ToolStripStatusLabel1.Text = "Sort is running: " & moveTo & "/" & totalMoves & " complete"
            StatusStrip1.Refresh()

            If pastPos(0) <> Nothing Then
                For Each j In pastPos
                    If j > ordArr(i) Then
                        shiftVal += 1
                    End If
                Next
                ReDim Preserve pastPos(UBound(pastPos) + 1)
                pastPos(UBound(pastPos)) = ordArr(i)
            Else
                pastPos(0) = ordArr(i)
            End If

            nextToMove = nextToMove + shiftVal
            If nextToMove <> moveTo Then

                length = SendMessage(reordListHand, LB_GETTEXTLEN, nextToMove - 1, 0)
                nextMoveString = Space(length)
                Call SendStrMessage(reordListHand, LB_GETTEXT, nextToMove - 1, nextMoveString)

                If nextToMove = UBound(ordArr) + 1 Then
                    valRet = SendNotifyMessage(reordListHand, LB_SETCURSEL, nextToMove - 1, Nothing)
                    valRet = SendNotifyMessage(reordListHand, WM_KEYDOWN, VK_DOWN, 0)
                Else
                    valRet = SendNotifyMessage(reordListHand, LB_SETCURSEL, nextToMove, Nothing)
                    valRet = SendNotifyMessage(reordListHand, WM_KEYDOWN, VK_UP, 0)
                End If

                valRet = SendNotifyMessage(moveButtonHand, BM_CLICK, 0, Nothing)

                If moveTo = UBound(ordArr) + 1 Then
                    valRet = SendNotifyMessage(reordListHand, LB_SETCURSEL, moveTo - 1, Nothing)
                    valRet = SendNotifyMessage(reordListHand, WM_KEYDOWN, VK_DOWN, 0)
                Else
                    valRet = SendNotifyMessage(reordListHand, LB_SETCURSEL, moveTo, Nothing)
                    valRet = SendNotifyMessage(reordListHand, WM_KEYDOWN, VK_UP, 0)
                End If

                timer = Now()
                Do While moveToString <> nextMoveString
                    length = SendMessage(reordListHand, LB_GETTEXTLEN, moveTo - 1, 0)
                    moveToString = Space(length)

                    On Error Resume Next
                    Call SendStrMessage(reordListHand, LB_GETTEXT, moveTo - 1, moveToString)
                    On Error GoTo 0

                    If Now() > timer.AddSeconds(5) Then
                        MsgBox("Failed to make a move correctly. Please close graph tree reordering and try to sort again.",, "Error")
                        Exit Sub
                    End If
                Loop

            End If
        Next

        valRet = SendMessage(okButtonHand, BM_CLICK, 0, Nothing)

        Dim Result As TimeSpan = Now() - startTime

        Status1.Text = "> Sort (" & selProduct.PartNumber & ") Complete"
        Status2.Text = "> " & selProduct.Products.Count & " products were reordered."
        Status3.Text = "> " & CInt(Result.TotalMilliseconds) / 1000 & " seconds."

        Call loadSelValues()

    End Sub

    Function returnOrder() As Integer()

        Dim currentOrd() As Integer
        Dim x As Integer
        Dim y As Integer

        ReDim currentOrd(selProduct.Products.Count - 1)
        For x = 0 To selProduct.Products.Count - 1 Step 1
            For y = 0 To selProduct.Products.Count - 1 Step 1
                If SortedValues.Items.Item(y).ToString = initialOrder(x + 1) Then
                    currentOrd(y) = x
                End If
            Next
        Next

        returnOrder = currentOrd
    End Function

    Private Sub BoeDetSort_Click(sender As Object, e As EventArgs) Handles BoeDetSort.Click
        Dim i As Integer
        Dim nameNumSplit() As String
        Dim numSplit() As String
        Dim currentNum As Double
        Dim arrNums() As Double
        Dim arrNames() As String
        Dim modifier As Integer
        Dim nameHolder As String

        ReDim arrNums(SortedValues.Items.Count - 1)
        ReDim arrNames(SortedValues.Items.Count - 1)

        For i = 0 To SortedValues.Items.Count - 1 Step 1
            nameNumSplit = Split(SortedValues.Items.Item(i), "||")
            numSplit = Split(nameNumSplit(1), "_")
            If UBound(numSplit) = 2 Then
                nameHolder = numSplit(1)
                If InStr(numSplit(1), "ALTREF") Then
                    numSplit(1) = Strings.Left(numSplit(1), InStr(numSplit(1), "ALTREF") - 1)

                    nameHolder = Strings.Right(nameHolder, Len(nameHolder) - Len(numSplit(1)) - 6)
                    If IsNumeric(nameHolder) Then
                        modifier = CInt(2 & nameHolder)
                    Else
                        modifier = 2
                    End If
                ElseIf InStr(numSplit(1), "ALT") Then
                    numSplit(1) = Strings.Left(numSplit(1), InStr(numSplit(1), "ALT") - 1)
                    nameHolder = Strings.Right(nameHolder, Len(nameHolder) - Len(numSplit(1)) - 3)
                    If IsNumeric(nameHolder) Then
                        modifier = CInt(1 & nameHolder)
                    Else
                        modifier = 1
                    End If
                ElseIf InStr(numSplit(1), "REF") Then
                    numSplit(1) = Strings.Left(numSplit(1), InStr(numSplit(1), "REF") - 1)
                    nameHolder = Strings.Right(nameHolder, Len(nameHolder) - Len(numSplit(1)) - 3)
                    If IsNumeric(nameHolder) Then
                        modifier = CInt(3 & nameHolder)
                    Else
                        modifier = 3
                    End If
                Else
                    modifier = 0
                End If

                If IsNumeric(numSplit(1)) Then
                    currentNum = CDbl(numSplit(1) & "." & modifier)
                ElseIf Len(numSplit(1)) - 1 > 0 Then
                    If IsNumeric(Strings.Left(numSplit(1), Len(numSplit(1)) - 1)) Then
                        currentNum = CDbl(Asc(Strings.Left(numSplit(1), 1)) & Strings.Left(numSplit(1), Len(numSplit(1)) - 1) & "." & modifier)
                    End If
                Else
                    currentNum = 99999999
                End If

            Else
                currentNum = 999999999
            End If

            arrNums(i) = currentNum
            arrNames(i) = SortedValues.Items.Item(i)
        Next

        Call stableSort(arrNums, arrNames)

        For i = 0 To SortedValues.Items.Count - 1 Step 1
            nameNumSplit = Split(SortedValues.Items.Item(i), "||")
            SortedValues.Items.Item(i) = arrNames(i)
        Next
    End Sub

    Private Sub TableLayoutPanel1_Click(sender As Object, e As EventArgs) Handles TableLayoutPanel1.Click
        InputValues.ClearSelected()
        SortedValues.ClearSelected()
    End Sub

    Private Sub TableLayoutPanel2_Click(sender As Object, e As EventArgs) Handles TableLayoutPanel2.Click
        InputValues.ClearSelected()
        SortedValues.ClearSelected()
    End Sub

    Private Sub TableLayoutPanel3_Click(sender As Object, e As EventArgs) Handles TableLayoutPanel3.Click
        InputValues.ClearSelected()
        SortedValues.ClearSelected()
    End Sub

    Private Sub TableLayoutPanel4_Click(sender As Object, e As EventArgs) Handles TableLayoutPanel4.Click
        InputValues.ClearSelected()
        SortedValues.ClearSelected()
    End Sub
    Private Sub TableLayoutPanel5_Click(sender As Object, e As EventArgs) Handles TableLayoutPanel5.Click
        InputValues.ClearSelected()
        SortedValues.ClearSelected()
    End Sub
    Private Sub TableLayoutPanel6_Click(sender As Object, e As EventArgs) Handles TableLayoutPanel5.Click
        InputValues.ClearSelected()
        SortedValues.ClearSelected()
    End Sub
    Private Sub TableLayoutPanel7_Click(sender As Object, e As EventArgs) Handles TableLayoutPanel7.Click
        InputValues.ClearSelected()
        SortedValues.ClearSelected()
    End Sub

    Private Sub MoveUp_Click(sender As Object, e As EventArgs) Handles MoveUp.Click
        Dim holder As String
        For i = 1 To SortedValues.Items.Count - 1
            If Not SortedValues.GetSelected(i - 1) And SortedValues.GetSelected(i) Then
                holder = SortedValues.Items.Item(i - 1)
                SortedValues.Items.Item(i - 1) = SortedValues.Items.Item(i)
                SortedValues.Items.Item(i) = holder
                SortedValues.SetSelected(i - 1, True)
                SortedValues.SetSelected(i, False)
            End If
        Next
    End Sub

    Private Sub MoveDown_Click(sender As Object, e As EventArgs) Handles MoveDown.Click
        Dim holder As String
        For i = SortedValues.Items.Count - 2 To 0 Step -1
            If Not SortedValues.GetSelected(i + 1) And SortedValues.GetSelected(i) Then
                holder = SortedValues.Items.Item(i + 1)
                SortedValues.Items.Item(i + 1) = SortedValues.Items.Item(i)
                SortedValues.Items.Item(i) = holder
                SortedValues.SetSelected(i + 1, True)
                SortedValues.SetSelected(i, False)
            End If
        Next
    End Sub

    Private Sub NameSort_Click(sender As Object, e As EventArgs) Handles NameSort.Click

        Dim arrSort() As String
        If SortedValues.Items.Count > 0 Then
            ReDim arrSort(0)
            arrSort(0) = SortedValues.Items.Item(0)
            For i = 1 To SortedValues.Items.Count - 1
                ReDim Preserve arrSort(UBound(arrSort) + 1)
                arrSort(UBound(arrSort)) = SortedValues.Items.Item(i)
            Next

            Dim myComparer = New StringLogicalComparer
            Array.Sort(arrSort, myComparer)

            For i = 0 To SortedValues.Items.Count - 1
                SortedValues.Items.Item(i) = arrSort(i)
            Next

        End If
    End Sub

    Sub stableSort(ByRef keyArr() As Double, ByRef valArr() As String)
        Dim i As Integer
        Dim j As Integer
        Dim numHold As Double
        Dim nameHold As String

        For i = 0 To UBound(keyArr)
            For j = 1 To UBound(keyArr)
                If keyArr(j) < keyArr(j - 1) Then
                    numHold = keyArr(j - 1)
                    keyArr(j - 1) = keyArr(j)
                    keyArr(j) = numHold

                    nameHold = valArr(j - 1)
                    valArr(j - 1) = valArr(j)
                    valArr(j) = nameHold
                End If
            Next
        Next
    End Sub

    Private Sub Invert_Click(sender As Object, e As EventArgs) Handles Invert.Click
        Dim arrSort() As String

        If SortedValues.Items.Count > 0 Then
            ReDim arrSort(0)
            arrSort(0) = SortedValues.Items.Item(0)
            For i = 1 To SortedValues.Items.Count - 1
                ReDim Preserve arrSort(UBound(arrSort) + 1)
                arrSort(UBound(arrSort)) = SortedValues.Items.Item(i)
            Next

            Array.Reverse(arrSort)

            For i = 0 To SortedValues.Items.Count - 1
                SortedValues.Items.Item(i) = arrSort(i)
            Next
        End If
    End Sub

    Private Sub BoeAutoSort_CheckedChanged(sender As Object, e As EventArgs) Handles BoeAutoSort.CheckedChanged
        If BoeAutoSort.Checked Then
            NamAutoSort.Checked = False
        End If
    End Sub

    Private Sub NamAutoSort_CheckedChanged(sender As Object, e As EventArgs) Handles NamAutoSort.CheckedChanged
        If NamAutoSort.Checked Then
            BoeAutoSort.Checked = False
        End If
    End Sub

    Private Sub AscentSort_Activated(sender As Object, e As EventArgs) Handles Me.Activated
        Me.Opacity = 1.0
    End Sub

    Private Sub AscentSort_Deactivate(sender As Object, e As EventArgs) Handles Me.Deactivate
        Me.Opacity = 0.625
    End Sub

    Public Class StringLogicalComparer
        Implements IComparer(Of String)

        Private Declare Unicode Function StrCmpLogicalW Lib "shlwapi" (ByVal s1 As String, ByVal s2 As String) As Integer

        Public Function Compare(x As String, y As String) As Integer Implements IComparer(Of String).Compare
            Return StrCmpLogicalW(x, y)
        End Function

    End Class
End Class

